let tabData = {};

let MCMS_MCSS_11 = {};
MCMS_MCSS_11.questionData = {};
MCMS_MCSS_11.optionArr = [];
MCMS_MCSS_11.mainContainer;
MCMS_MCSS_11.maxOptions = 4;
MCMS_MCSS_11.prevOption;
MCMS_MCSS_11.userAnswer;
MCMS_MCSS_11.correctAnswer;
MCMS_MCSS_11.currentAttempt;
MCMS_MCSS_11.activityCompleted = false;
MCMS_MCSS_11.currentGroup;
MCMS_MCSS_11.group;

let eventMgr = new EventManager();
let _shell_wrapper = $('#shell_wrapper');


MCMS_MCSS_11.initMCMS = function (data) {

	MCMS_MCSS_11.mainContainer = $("#mcmsContainer").find("#mcmsHolder");

	MCMS_MCSS_11.questionData = data;
	MCMS_MCSS_11.currentAttempt = 0;
	MCMS_MCSS_11.currentGroup = 0;
	MCMS_MCSS_11.group = null;

	Feedback.init($("#mcmsFeedbackBox"), $("#mcmsContainer"));

	eventMgr.removeControlEventListener(Feedback, "feedbackClosed", MCMS_MCSS_11.closeFeedback);
	eventMgr.addControlEventListener(Feedback, "feedbackClosed", MCMS_MCSS_11.closeFeedback);

	//initialize submit button

	SubmitButton.init($("#mcmsHolder").find("#mcmsSubmitBtn"));
	SubmitButton.chkSubmitEnable(false);

	$("#mcmsContinueBtn").addClass("disabled")
	$("#feedbackClose").addClass("disabled").addClass("d-hide");

	MCMS_MCSS_11.createOptions();
	MCMS_MCSS_11.disableOptions();

	MCMS_MCSS_11.showQuestion();
	MCMS_MCSS_11.mainContainer.find("#mcmsNextBtn").hide();


	$("#mcmsHolder").addClass(data.id);
	$(".popup").addClass('iGPopup');

	setTimeout(function () {
		eventMgr.removeControlEventListener(SubmitButton, "submitClicked", MCMS_MCSS_11.submitClicked);
		eventMgr.addControlEventListener(SubmitButton, "submitClicked", MCMS_MCSS_11.submitClicked);
		MCMS_MCSS_11.addTabIndexingOnQuestion();
	}, 300);
	$("#btn_cc").addClass("CC_disabled");
}


MCMS_MCSS_11.hintBox = function () {

	let _policyText = MCMS_MCSS_11.questionData.policyText;
	let _clueText = MCMS_MCSS_11.questionData.clueText;

	if (_policyText && _policyText != '') {
		$("#policyIcon").removeClass('d-hide');
	}

	if (_clueText && _clueText != '') {
		$("#clueIcon").removeClass('d-hide');
	}

	let _hint_btns = $(".hint_btn");
	_hint_btns.off("click").removeClass("active").addClass("disabled");

}


MCMS_MCSS_11.addEventOnHint = function () {

	let _hint_btns = $(".hint_btn");

	_hint_btns.off("click").on("click", function () {

		let _btn = $(this);
		if (_btn.hasClass("active")) {


			let _text = MCMS_MCSS_11.questionData[_btn.attr('data-text')];
			$("#hintContent").html(_text);

			$("#hintHeader").html(_btn.text());
			$("#hintIcon").removeAttr('class').addClass(_btn.attr('id'));

			let _holder = $("#hintBoxPopup")
			_holder.removeClass('d-hide').addClass("fadeInUpAnim");

			let _holderCover = $("#hintCover")
			_holderCover.addClass('d-show');

			let _close_btn = _holder.find("#hintBoxClose")
			_close_btn.unbind();
			_close_btn.off("click").on("click", function () {
				_holder.addClass('d-hide').removeClass("fadeInUpAnim");
				_holderCover.removeClass('d-show');
			}).addClass("active");

		}
	}).removeClass("disabled").addClass("active")
}


MCMS_MCSS_11.createOptions = function () {

	MCMS_MCSS_11.userAnswer = [];
	let type = MCMS_MCSS_11.questionData.type;

	for (let c = 0; c < MCMS_MCSS_11.questionData.optionsGroup.length; c++) {
		MCMS_MCSS_11.userAnswer[c] = []
		MCMS_MCSS_11.optionArr.push([])

		for (let i = 0; i < MCMS_MCSS_11.questionData.optionsGroup[c].group.length; i++) {

			let option = $(MCMS_MCSS_11.mainContainer.find("#mcmsOptionContainer").find(".cloneOption")).clone();
			option.removeClass("cloneOption");

			if (type == "mcss") {
				option.find('#optionBox').addClass('radio').removeClass('checkBox');
			} else {
				option.find('#optionBox').addClass('checkBox').removeClass('radio');
			}

			MCMS_MCSS_11.userAnswer[c][i] = 0;

			let opt = new Option(option, type, i);
			MCMS_MCSS_11.optionArr[c][i] = opt;

			eventMgr.addControlEventListener(opt.holder, "optionClicked", MCMS_MCSS_11.mcmsOptionClicked);

			MCMS_MCSS_11.mainContainer.find(".group" + (c + 1)).append(opt.holder)
			option.appendTo(MCMS_MCSS_11.mainContainer.find(".group" + (c + 1)));

		}
	}
};

MCMS_MCSS_11.addListeners = function () {

	for (let c = 0; c < MCMS_MCSS_11.questionData.optionsGroup.length; c++) {
		for (let i = 0; i < MCMS_MCSS_11.questionData.optionsGroup[c].group.length; i++) {
			let option = MCMS_MCSS_11.optionArr[c][i];
			option.addListeners();
		}
	}
	// MCMS_MCSS_11.addEventOnHint();
};

MCMS_MCSS_11.showQuestion = function () {
	MCMS_MCSS_11.initializeMCMS();
};

/*MCMS functionality*/
MCMS_MCSS_11.initializeMCMS = function () {

	MCMS_MCSS_11.userAnswer = [];
	MCMS_MCSS_11.correctAnswer = [];

	MCMS_MCSS_11.activityCompleted = false;

	let _mcmsContainer = $("#mcmsContainer");

	$(".mcmsQuestionTxt").html(MCMS_MCSS_11.questionData.questionText);
	$(".qBoxImg").attr("alt", MCMS_MCSS_11.questionData.qBoxImg);
	$(".char-img").attr("alt", MCMS_MCSS_11.questionData.charImg);
	// $(".questionID").html(MCMS_MCSS_11.questionData.questionID);

	//_mcmsContainer.find("#mcmsScenarioTxt").html(MCMS_MCSS_11.questionData.scenarioText);

	_mcmsContainer.find("#mcmsInstructionTxt").html(MCMS_MCSS_11.questionData.instructionText);

	_mcmsContainer.find(".mcssOption").addClass("hiddenOption");

	for (let c = 0; c < MCMS_MCSS_11.questionData.optionsGroup.length; c++) {
		MCMS_MCSS_11.userAnswer[c] = [];
		for (let i = 0; i < MCMS_MCSS_11.questionData.optionsGroup[c].group.length; i++) {
			MCMS_MCSS_11.userAnswer[c][i] = 0;
			MCMS_MCSS_11.correctAnswer[c] = MCMS_MCSS_11.questionData.optionsGroup[c].correctAnswer;
			let option = MCMS_MCSS_11.optionArr[c][i];
			option.showOption("" + MCMS_MCSS_11.questionData.optionsGroup[c].group[i] + "");
		}
	}

	$(".hiddenOption").remove();

	let _isDebugging = false;

	try {
		if (_user_details) {
			_isDebugging = _user_details['isDebugging'] || false;
		}
	} catch (err) {

	}

	try {
		if (_isDebugging) {
			let __qTxt = MCMS_MCSS_11.questionData.id + ' - ' + MCMS_MCSS_11.questionData.questionText + ' - ' + MCMS_MCSS_11.correctAnswer;
			_mcmsContainer.find("#mcmsQuestionTxt").html(__qTxt);
		}
	} catch (err) {

	}

	$(".activityHolder").removeClass("d-hide")

}

MCMS_MCSS_11.resetMCMS = function () {
	MCMS_MCSS_11.userAnswer = [];
	for (let c = 0; c < MCMS_MCSS_11.questionData.optionsGroup.length; c++) {
		MCMS_MCSS_11.userAnswer[c] = [];
		for (let i = 0; i < MCMS_MCSS_11.questionData.optionsGroup[c].group.length; i++) {
			MCMS_MCSS_11.userAnswer[c][i] = 0;
			let option = MCMS_MCSS_11.optionArr[c][i];
			option.reset();
		}
	}
}


MCMS_MCSS_11.mcmsOptionClicked = function (evt) {

	let clicked = $(evt.target).parent().parent().parent();

	let str = clicked.attr("id");
	let _oNo = parseInt(str.split("_")[1]);
	let _isActive = false;

	MCMS_MCSS_11.currentGroup = parseInt(clicked.parent().attr("class").slice(5, 6));

	let _optionbox = clicked.find("#optionBox");
	if (MCMS_MCSS_11.questionData.type === "mcss") {
		MCMS_MCSS_11.resetMCMS();
		_optionbox.addClass("MCSSbulletPointsSelected");
		_optionbox.parents(".mcssOption").addClass("selected")
		_optionbox.attr({ "aria-checked": "true" });
		MCMS_MCSS_11.userAnswer[MCMS_MCSS_11.currentGroup - 1][_oNo - 1] = 1;
	} else {
		if (_optionbox.hasClass("MCMSbulletPointsSelected")) {
			_optionbox.attr({ "aria-checked": "true" });
			MCMS_MCSS_11.userAnswer[MCMS_MCSS_11.currentGroup - 1][_oNo - 1] = 1;
		} else {
			_optionbox.attr({ "aria-checked": "false" });
			MCMS_MCSS_11.userAnswer[MCMS_MCSS_11.currentGroup - 1][_oNo - 1] = 0;
		}
	}



	let _count = 0;
	for (let i = 0; i < MCMS_MCSS_11.userAnswer[MCMS_MCSS_11.currentGroup - 1].length; i++) {
		if (MCMS_MCSS_11.userAnswer[MCMS_MCSS_11.currentGroup - 1][i] == 1) {
			_count++
		}
	}
	if (_count >= 1) {
		_isActive = true;
	}
	SubmitButton.chkSubmitEnable(_isActive);

}

MCMS_MCSS_11.submitClicked = function (evt) {
	if (MCMS_MCSS_11.userAnswer.length > 0 && !SubmitButton.holder.eq(0).hasClass('disabled')) {
		MCMS_MCSS_11.chkUserAnswer();
		MCMS_MCSS_11.disableOptions();
	}
};

MCMS_MCSS_11.disableOptions = function () {
	for (let c = 0; c < MCMS_MCSS_11.questionData.optionsGroup.length; c++) {
		for (let i = 0; i < MCMS_MCSS_11.questionData.optionsGroup[c].group.length; i++) {
			let option = MCMS_MCSS_11.optionArr[c][i];
			option.disable();
		}
	}
}



MCMS_MCSS_11.chkUserAnswer = function () {

	SubmitButton.chkSubmitEnable(false);

	let result = 1;
	let uResult = {}
	let cCount = 0;
	let type = MCMS_MCSS_11.questionData.type;

	for (let i = 0; i < MCMS_MCSS_11.userAnswer.length; i++) {
		for (let c = 0; c < MCMS_MCSS_11.userAnswer[i].length; c++) {
			if ((MCMS_MCSS_11.userAnswer[i][c] === MCMS_MCSS_11.correctAnswer[i][c]) && (MCMS_MCSS_11.correctAnswer[i][c] == 1)) {
				uResult[i] = 1;
				cCount++;
			} else {
				uResult[i] = 0;
			}
			if (MCMS_MCSS_11.userAnswer[i][c] != MCMS_MCSS_11.correctAnswer[i][c]) {
				result = 0;
			}
		}
	}

	uResult['cCount'] = cCount;
	uResult['result'] = result;
	uResult['type'] = type;


	MCMS_MCSS_11.currentAttempt++;

	_shell_wrapper.trigger('activityResult_3', {
		'qNo': parseInt(MCMS_MCSS_11.questionData['id']),
		'attemptNo': MCMS_MCSS_11.currentAttempt,
		'cAns': MCMS_MCSS_11.correctAnswer[0],
		'uAns': MCMS_MCSS_11.userAnswer[0],
		'type': type,
		'result': result,
		'uResult': uResult,
	});

	MCMS_MCSS_11.showFeedback(uResult);


};


MCMS_MCSS_11.showFeedback = function (uResult) {

	let result = uResult['result'] || 0;
	let cCount = uResult['cCount'] || 0;

	if (MCMS_MCSS_11.questionData.responseType !== "") {

		$(".feedBackContent").show();
		$("#hintCoverFeedback").addClass('d-show');
		$("#mcmsFeedbackBox").addClass("fadeInUpAnim");

		setTimeout(function () {
			$(".full_box").focus();
			$(".full_box").focusout(function () {
				$(".feedBackContent .close_icon").focus();
			})
		}, 500);

		$(".feedBackContent").show().css("display", "block !important")
		$("#mcmsFeedbackBox").show().css("display", "block !important")

		let _response = null;

		if (MCMS_MCSS_11.questionData.responseType == "genericResponse") {
			_response = null;
			let __response = MCMS_MCSS_11.questionData.genericResponse;

			let type = MCMS_MCSS_11.questionData.type;
			let isGroup = MCMS_MCSS_11.questionData.isGroup;

			if ((type == "mcss") || (isGroup == "security")) {
				if (result) {
					_response = __response.correct;
				} else {
					_response = __response.incorrect;
				}
			} else {
				if (result) {
					_response = __response.correct;
				} else {
					_response = __response.incorrect;
				}
			}


			Feedback.showFeedback(_response.description);

		} else if (MCMS_MCSS_11.questionData.responseType == "specificResponse") {

			let feedStr = "";
			let count = 0;
			_response = null;

			for (let c = 0; c < MCMS_MCSS_11.userAnswer[0].length; c++) {
				let i = MCMS_MCSS_11.userAnswer[0][c]
				if (i) {
					count++;
					_response = MCMS_MCSS_11.questionData.specificResponse.response[c];
					feedStr += _response.description;

					if (count > 0) {
						feedStr += ""
					}
				}
			}
			Feedback.showFeedback(feedStr);
		}

		if (result) {
			MCMS_MCSS_11.showTickOnly();
		} else {
			if (MCMS_MCSS_11.currentAttempt >= MCMS_MCSS_11.questionData.maxAttempts) {
				MCMS_MCSS_11.showTickOnly();
			}
		}

		if (_response && _response.audio) {

			MCMS_MCSS_11.updateAudio(_response.audio, function () {
				MCMS_MCSS_11.checkIsNextQuestion(result);
			})
		} else {
			MCMS_MCSS_11.checkIsNextQuestion(result);
		}


		setTimeout(function () {
			let isNextQuestion = MCMS_MCSS_11.questionData.isNextQuestion;
			if (isNextQuestion && !result) {
				MCMS_MCSS_11.addTabIndexingOnFeedback();
			} else {
				MCMS_MCSS_11.addTabIndexingOnFeedback_1();
			}

			_shell_wrapper.off("activityResult_3");
			_shell_wrapper.off("activityResult");
			// _shell_wrapper.off("closeActivity");
			Utils.pageCompleted();
		}, 600)

		$("#mcmsFeedbackBox").draggable({
			disabled: true
		});
		$("#feedbackHeader").css('cursor', 'default');

	}


};

MCMS_MCSS_11.checkIsNextQuestion = function (result) {
	let isNextQuestion = MCMS_MCSS_11.questionData.isNextQuestion;

	if (isNextQuestion && !result) {
		$("#feedbackClose").removeClass("disabled").removeClass("d-hide");
	} else {
		$("#feedbackClose").removeClass("disabled");
		Utils.pageCompleted();
	}
	//	if(isNextQuestion){
	$("#feedbackClose").removeClass("disabled").removeClass("d-hide");
	//	}
}

MCMS_MCSS_11.updateAudio = function (_aData, callback) {
	try {
		_aData['callback'] = function () {
			callback();
		}
		if (_simple_audio) {
			_simple_audio.changeAudio(_aData);
		}
	} catch (err) {

	}
}

MCMS_MCSS_11.closeFeedback = function () {
	$("#mcmsFeedbackBox").removeClass("fadeInUpAnim");
	$("#mcmsFeedbackBox").addClass("fadeInUpAnim");
	$("#hintCoverFeedback").removeClass('d-show');
	_shell_wrapper.trigger('closeActivity');
	// Utils.pageCompleted();
};

MCMS_MCSS_11.showTickOnly = function () {
	MCMS_MCSS_11.showSolution();
	// MCMS_MCSS_11.checkUserAns();
}

MCMS_MCSS_11.checkUserAns = function () {
	$(".mcssOption").addClass("eventNone");
	for (let c = 0; c < MCMS_MCSS_11.questionData.optionsGroup.length; c++) {
		for (let i = 0; i < MCMS_MCSS_11.questionData.optionsGroup[c].group.length; i++) {
			let option = MCMS_MCSS_11.optionArr[c][i];
			if (MCMS_MCSS_11.userAnswer[c][i] == 1) {
				if (MCMS_MCSS_11.correctAnswer[c][i] == 1) {
					option.showTickCross("mcssTick");
				} else {
					option.showTickCross("mcssCross");
				}
			}
		}
	}
}

MCMS_MCSS_11.showSolution = function () {

	// MCMS_MCSS_11.markPageComplete();

	$(".mcssOption").addClass("eventNone");
	for (let c = 0; c < MCMS_MCSS_11.questionData.optionsGroup.length; c++) {
		for (let i = 0; i < MCMS_MCSS_11.questionData.optionsGroup[c].group.length; i++) {
			let option = MCMS_MCSS_11.optionArr[c][i];
			if (MCMS_MCSS_11.correctAnswer[c][i] == 1) {
				option.showTickCross("mcssTick");
			} else {
				option.showTickCross("mcssCross");
			}
		}
	}
}


MCMS_MCSS_11.markPageComplete = function () {
	if (!MCMS_MCSS_11.activityCompleted) {
		MCMS_MCSS_11.activityCompleted = true;
		eventMgr.dispatchCustomEvent(MCMS, "templateActivityCompleted", "", "");
	}
}

//randomization
MCMS_MCSS_11.randomizeArr = function (arr) {
	let randomizeArr = arr.concat();
	randomizeArr.sort(MCMS_MCSS_11.shuffle);
	return randomizeArr;
};

MCMS_MCSS_11.shuffle = function () {
	let ran = 0.5 - Math.random();
	return ran;
};

MCMS_MCSS_11.chkActivityCompletion = function () { }

MCMS_MCSS_11.addTabIndexingOnQuestion = function () {
	var _tabElements = {
		'elements': [
			{
				'selector': "#mcmsHolder",
				'aria-label': ' ',
				'role': 'none'
			},
			{
				'selector': "#mcmsHolder .imageArea .qBoxImg"
			},
			{
				'selector': "#mcmsHolder .queContainer .mcmsQuestionTxt"
			},
			{
				'selector': "#mcmsHolder .activityinstruction"
			},
			{
				'selector': "#mcmsHolder .option_box_wrap .option-holder .checkBox",
				'role': 'checkbox',
				'aria-checked': 'false'
			},
			{
				'selector': "#mcmsHolder .option_box_wrap .option-holder .radio",
				'role': 'radio',
				'aria-checked': 'false'
			},
			{
				'selector': "#mcmsHolder .btnCont .pop_btn",
				"role": "button"
			}
		],
		'sIndex': 500,
		'nIndex': 1
	};
	Utils.addEventsForTabIndex(_tabElements)

}

MCMS_MCSS_11.addTabIndexingOnFeedback = function () {
	var _tabElements = {
		'elements': [
			{
				'selector': "#mcmsFeedbackBox",
				'aria-label': ' ',
				'role': 'none'
			},
			{
				'selector': "#mcmsFeedbackBox #feedbackContent"
			},
			{
				'selector': "#mcmsFeedbackBox .close_btn",
				"role": "button"
			}
		],
		'sIndex': 500,
		'nIndex': 1
	};
	$("#mcmsFeedbackBox").addClass('iGPopup');
	Utils.addEventsForTabIndex(_tabElements)

	setTimeout(function () {
		$("#mcmsFeedbackBox").focus();
	}, 600)
}

MCMS_MCSS_11.addTabIndexingOnFeedback_1 = function () {
	var _tabElements = {
		'elements': [
			{
				'selector': "#mcmsFeedbackBox",
				'aria-label': ' ',
				'role': 'none'
			},
			{
				'selector': "#mcmsFeedbackBox #feedbackContent"
			},
			{
				'selector': "#mcmsFeedbackBox .close_btn",
				"role": "button"
			}
		],
		'sIndex': 500,
		'nIndex': 1
	};
	$("#mcmsFeedbackBox").removeClass('iGPopup');
	Utils.addEventsForTabIndex(_tabElements);
	setTimeout(function () {
		$("#mcmsFeedbackBox").focus();
	}, 600)

}

var initMCMS_MCSS_11 = (function () {

	this.init = function (data, callback) {
		_aData = data;

		eventMgr.addControlEventListener(MCMS_MCSS_11, "templateActivityCompleted", MCMS_MCSS_11.chkActivityCompletion);

		MCMS_MCSS_11.initMCMS(_aData);

		_shell_wrapper.off("start_MCMS_MCSS_11").on("start_MCMS_MCSS_11", function () {
			MCMS_MCSS_11.addListeners();
		});

	};

	return this;

})